import { ChainName, PlatformName, ChainToPlatform } from "@wormhole-foundation/sdk-base";
import { UniversalAddress } from "./universalAddress";
export interface Address {
    unwrap(): unknown;
    toString(): string;
    toUint8Array(): Uint8Array;
    toUniversalAddress(): UniversalAddress;
}
declare global {
    namespace Wormhole {
        interface PlatformToNativeAddressMapping {
        }
    }
}
export type MappedPlatforms = keyof Wormhole.PlatformToNativeAddressMapping;
type ChainOrPlatformToPlatform<T extends ChainName | PlatformName> = T extends ChainName ? ChainToPlatform<T> : T;
type GetNativeAddress<T extends PlatformName> = T extends MappedPlatforms ? Wormhole.PlatformToNativeAddressMapping[T] : never;
export type NativeAddress<T extends PlatformName | ChainName> = GetNativeAddress<ChainOrPlatformToPlatform<T>>;
export type UniversalOrNative<P extends PlatformName> = UniversalAddress | NativeAddress<P>;
export type ChainAddress<C extends ChainName = ChainName> = {
    readonly chain: C;
    readonly address: UniversalAddress | NativeAddress<C>;
};
type NativeAddressCtr = new (ua: UniversalAddress | string | Uint8Array) => Address;
export declare function registerNative<P extends MappedPlatforms>(platform: P, ctr: NativeAddressCtr): void;
export declare function nativeIsRegistered<T extends PlatformName | ChainName>(chainOrPlatform: T): boolean;
export declare function toNative<T extends PlatformName | ChainName>(chainOrPlatform: T, ua: UniversalAddress | string | Uint8Array): NativeAddress<T>;
export {};
//# sourceMappingURL=address.d.ts.map