"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TokenBridge = exports.supportsAutomaticTokenBridge = exports.supportsTokenBridge = exports.ErrNotWrapped = void 0;
const sdk_base_1 = require("@wormhole-foundation/sdk-base");
const vaa_1 = require("../vaa");
require("../payloads/tokenBridge");
const ErrNotWrapped = (token) => new Error(`Token ${token} is not a wrapped asset`);
exports.ErrNotWrapped = ErrNotWrapped;
function supportsTokenBridge(thing) {
    return typeof thing.getTokenBridge === "function";
}
exports.supportsTokenBridge = supportsTokenBridge;
function supportsAutomaticTokenBridge(thing) {
    return (typeof thing.getAutomaticTokenBridge ===
        "function");
}
exports.supportsAutomaticTokenBridge = supportsAutomaticTokenBridge;
var TokenBridge;
(function (TokenBridge) {
    // export const transferPayloadNames = ["Transfer", "TransferWithPayload"] as const;
    // export type TransferPayloadNames = typeof transferPayloadNames[number];
    TokenBridge.getTransferDiscriminator = (0, sdk_base_1.lazyInstantiate)(() => (0, vaa_1.payloadDiscriminator)(["TokenBridge", ["Transfer", "TransferWithPayload"]]));
})(TokenBridge || (exports.TokenBridge = TokenBridge = {}));
//# sourceMappingURL=tokenBridge.js.map