import { ChainName } from "@wormhole-foundation/sdk-base";
import { UnsignedTransaction } from "./unsignedTransaction";
import { SignedTx, TxHash } from "./types";
export type Signer = SignOnlySigner | SignAndSendSigner;
export declare function isSigner(thing: Signer | any): thing is Signer;
export interface SignOnlySigner {
    chain(): ChainName;
    address(): string;
    sign(tx: UnsignedTransaction[]): Promise<SignedTx[]>;
}
export declare function isSignOnlySigner(thing: SignOnlySigner | any): thing is SignOnlySigner;
export interface SignAndSendSigner {
    chain(): ChainName;
    address(): string;
    signAndSend(tx: UnsignedTransaction[]): Promise<TxHash[]>;
}
export declare function isSignAndSendSigner(thing: SignAndSendSigner | any): thing is SignAndSendSigner;
//# sourceMappingURL=signer.d.ts.map