import { PlatformName } from "@wormhole-foundation/sdk-base";
import { AnyAddress, ChainAddress, NativeAddress, RpcConnection, TokenBridge, UnsignedTransaction } from "../..";
export declare class MockTokenBridge<P extends PlatformName> implements TokenBridge<P> {
    readonly rpc: RpcConnection<P>;
    constructor(rpc: RpcConnection<P>);
    isWrappedAsset(token: AnyAddress): Promise<boolean>;
    getOriginalAsset(token: AnyAddress): Promise<ChainAddress>;
    hasWrappedAsset(original: ChainAddress): Promise<boolean>;
    getWrappedAsset(original: ChainAddress): Promise<NativeAddress<P>>;
    isTransferCompleted(vaa: TokenBridge.VAA<"Transfer" | "TransferWithPayload">): Promise<boolean>;
    createAttestation(address: AnyAddress): AsyncGenerator<UnsignedTransaction>;
    submitAttestation(vaa: TokenBridge.VAA<"AttestMeta">): AsyncGenerator<UnsignedTransaction>;
    transfer(sender: AnyAddress, recipient: ChainAddress, token: "native" | AnyAddress, amount: bigint, payload?: Uint8Array | undefined): AsyncGenerator<UnsignedTransaction>;
    redeem(sender: AnyAddress, vaa: TokenBridge.VAA<"Transfer" | "TransferWithPayload">, unwrapNative?: boolean | undefined): AsyncGenerator<UnsignedTransaction>;
    getWrappedNative(): Promise<NativeAddress<P>>;
}
//# sourceMappingURL=tokenBridge.d.ts.map